/**
 * Test case for create.
 * Runs with mocha.
 */
"use strict";

const create = require('../lib/create.js'),
    freeport = require('freeport'),
    assert = require('assert'),
    apemanApp = require('apeman-app'),
    request = require('request');

describe('create', () => {

    it('Create an app.', (done) => {
        let app = create({});
        assert.ok(app);
        freeport((err, port) => {
            assert.ifError(err);
            apemanApp('testing-app', {
                configuration: {
                    $apps: {
                        'testing-app': {
                            '/': [
                                require('apeman-app-format')(),
                                require('apeman-app-json')(),
                                app,
                                function (req, res, next) {
                                    res.send({
                                        foo: 'bar'
                                    })
                                }
                            ]
                        }
                    }
                },
                port: port
            }, (err, server) => {
                let baseUrl = 'http://localhost:' + port + '/';
                assert.ifError(err);
                request(baseUrl + '/foo.json', (err, res, body) => {
                    assert.ifError(err);
                    assert.equal(res.statusCode, 200);
                    let data = JSON.parse(body);
                    assert.deepEqual(data, {
                        "foo": "bar"
                    });
                    server.close();
                    done();
                });
            });
        });
    });
});

